require 'net/http'

class Shiori
  def Initialize
    @f = nil
    @path = ""
  end
  
  def load(path)
    @path = path
    @f = File.open(path+"log.txt", "w")
    @f.sync=true
    @f.puts path

#    request = Net::HTTP.new('antenna.yasagure.net', 80, nil, nil)
#    request.get('/') do |line|
#      puts line
#    end

    true
  end
  
  def unload
    @f.close
    true
  end

  def request(input_str)
    # debug output
    input_str.gsub!("\r\n", "\n")
    @f.puts(input_str)
    @f.puts
    @f.flush

    i=0
    input_str.each { |line| 
      if i==0 then
	if line =~ /GET SHIORI\/3.0/
	  value = get_string(input_str)
	  if value.empty? then
	    return "SHIORI/2.5 204 No Content\r\nSender: ruby_shiori\r\n\r\n"
	  else
	    return "SHIORI/3.0 200 OK\r\nSender: ruby_shiori\r\nValue: "+value+"\r\n\r\n"
	  end
	elsif line =~ /GET String SHIORI\/2.5/
	  value = get_string(input_str)
	  if value.empty? then
	    return "SHIORI/2.5 204 No Content\r\nSender: ruby_shiori\r\n\r\n"
	  else
	    return "SHIORI/2.5 200 OK\r\nSender: ruby_shiori\r\nString: "+value+"\r\n\r\n"
	  end
	elsif line =~ /NOTIFY SHIORI\/3.0/
	  return "SHIORI/3.0 200 OK\r\n\r\n"
	end
      end
    }

    "SHIORI/2.0 204 No Content\r\n\r\n"
  end

  def get_string(input_str)
    string_file = File.open(@path+"string.txt", "r")
    if input_str =~ /ID:\s*(.*)\n/ then
      key = $1
      puts "key: " + key
      string_file.each { |line|
	if line =~ /^#/ then
	    #
	elsif line =~ /(.*):\s*(.*)/
	  if key == $1 then
	    puts "key: " + $2 + "\n"
	    return $2
	  end
	end
      }
    end
    return ""
  end
end
