// ruby_shiori.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include "ruby_shiori.h"
#include "rubythread.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

std::string g_path;
VALUE g_shiori_instance;

extern "C" RUBY_SHIORI_API BOOL __cdecl load(HGLOBAL h, long len)
{
	g_path = std::string((char*)h, len);
	::GlobalFree(h);

	// RubyC^v^XbhJn
	CRubyThread::StartThread(g_path);

	// Call ruby script onload
	BOOL b = CRubyThread::OnLoad(g_path);

	return b;
}

extern "C" RUBY_SHIORI_API BOOL __cdecl unload()
{
	// Call ruby script onload
	BOOL b = CRubyThread::OnUnload();
	if (b)
		CRubyThread::EndThread();
	return b;
}

extern "C" RUBY_SHIORI_API HGLOBAL __cdecl request(HGLOBAL h, long *len)
{
	std::string input_str = std::string((char*)h, *len);
	::GlobalFree(h);

	std::string output_str = CRubyThread::Request(input_str);

	*len = output_str.length();
	h = ::GlobalAlloc(0, *len);
	memcpy(h, output_str.c_str(), *len);

	return h;
}
