// ShioriThread.h: CRubyThread NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RUBYTHREAD_H__21CA82E5_42B2_42DD_9129_80583E21944E__INCLUDED_)
#define AFX_RUBYTHREAD_H__21CA82E5_42B2_42DD_9129_80583E21944E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"

extern VALUE g_shiori_instance;

static UINT WM_MAIRUBYTHREAD_INITIALIZE = ::RegisterWindowMessage("WM_MAIRUBYTHREAD_INITIALIZE");
static UINT WM_MAIRUBYTHREAD_FINISH = ::RegisterWindowMessage("WM_MAIRUBYTHREAD_FINISH");

static UINT WM_MAIRUBYTHREAD_LOAD    = ::RegisterWindowMessage("WM_MAIRUBYTHREAD_ONLOAD");
static UINT WM_MAIRUBYTHREAD_UNLOAD  = ::RegisterWindowMessage("WM_MAIRUBYTHREAD_ONUNLOAD");
static UINT WM_MAIRUBYTHREAD_REQUEST = ::RegisterWindowMessage("WM_MAIRUBYTHREAD_REQUEST");

// Thread Loop
unsigned int __stdcall RubyThreadLoop(void* ptr);

class CRubyThread
{
	friend unsigned int __stdcall RubyThreadLoop(void* ptr);

public:
	CRubyThread();
	virtual ~CRubyThread();

	static bool StartThread(std::string&);	// XbhX^[g
	static bool EndThread();				// XbhXgbv

	static BOOL OnLoad(std::string&);
	static BOOL OnUnload();
	static std::string Request(std::string&);

protected:
	static HANDLE m_evEndProcess;		// ICxgʒm
	static DWORD  m_dwThreadHandle;		// Xbhnh
	static UINT   m_uiThreadID;			// XbhID
	static CRubyThread* m_pThis;		// B̃CX^X

	void InitializeRuby(char*);			// RubyvZX
	BOOL ThreadOnLoad(std::string&);
	BOOL ThreadOnUnload();
	std::string ThreadRequest(std::string&);
};
/*
	XbhnhstaticɂāAstartthread/endthreadNX\bh
	e폈̓NX\bhʂď˗ACX^XiXbhj
	bZ[W𓊂悤ɂH
*/

#endif // !defined(AFX_RUBYTHREAD_H__21CA82E5_42B2_42DD_9129_80583E21944E__INCLUDED_)
